%define svnsnapshot 0
%define cupsbasename cups
%if %{svnsnapshot}
%define cupsnameext %nil
%define cupssvnrevision 8703
%define cupsversion 1.4
%define cupsminorversion .0
%define cupsextraversion svn-r%{cupssvnrevision}
%define release %mkrel 0.%{cupssvnrevision}.1
%else
%define cupsnameext %nil
%define cupssvnrevision %nil
%define cupsversion 1.5.4
%define cupsminorversion %nil
%define cupsextraversion %nil
%define release %mkrel 1
%endif
%define cupstarballname %{cupsbasename}-%{cupsversion}%{cupsextraversion}

%define major	2
%define libname	%mklibname %{cupsbasename} %{major}%{cupsnameext}

# Links in the man page directories get deleted due to a bug in Mandriva's
# RPM helper script. So we copy the man pages for now
%define manpagelinks 0

%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

%define test 0
%{?_without_test: %global test 0}
%{?_with_test: %global test 1}

%global lspp 0

# {_exec_prefix}/lib/cups is correct, even on x86_64.
# It is not used for shared objects but for executables.
# It's more of a libexec-style ({_libexecdir}) usage,
# but we use lib for compatibility with 3rd party drivers (at upstream request).
%global cups_serverbin %{_exec_prefix}/lib/cups

##### GENERAL STUFF #####

Summary:	Common Unix Printing System - Server package
Name:		%{cupsbasename}%{cupsnameext}
Version:	%{cupsversion}%{cupsminorversion}
%define subrel 1
Release:	%{release}
License:	GPLv2 and LGPLv2
Group:		System/Printing
%define real_version %{version}

##### SOURCE FILES #####

Source: ftp://ftp.easysw.com/pub/cups/%{cupsversion}/%{cupstarballname}-source.tar.bz2

# Small C program to get list of all installed PPD files
Source1: poll_ppd_base.c
# Small C program to list the printer-specific options of a particular printer
Source2: lphelp.c
# Let printers have an ACL allowing rw for user lp, as our CUPS runs backends as lp:sys (bug 49407)
Source3: 69-printers_lp_user_fix.rules
# Complete replacement for startup script to have it the
# Mageia Linux way
Source5: cups.startup
# Script for cleaning up the PPD files
Source6: cleanppd.pl
# Perl script for automatic configuration of CUPS, especially access
# restrictions and broadcasting
Source7: correctcupsconfig
Source9: cups.logrotate
# Backend filter for nprint (Novell client) from Mark Horn
# (mark@hornclan.com)
Source11: http://www.hornclan.com/~mark/cups/nprint.2002011801
# AppleTalk/netatalk backend for CUPS
Source12: http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-backend.tar.bz2
Source13: http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-docu.pdf.bz2
Source14: http://www.linuxprinting.org/download/printing/photo_print
Source16: cjktexttops
# Nice level for now. bug #16387
Source18: cups.sysconfig
# Blacklist usblp module as it prevents USB printer detection
Source19: blacklist-cups-common.conf

### FEDORA PATCHES ###

Patch1: cups-no-gzip-man.patch
Patch2: cups-system-auth.patch
Patch3: cups-multilib.patch
Patch4: cups-serial.patch
Patch5: cups-banners.patch
Patch6: cups-serverbin-compat.patch
Patch7: cups-no-export-ssllibs.patch
Patch8: cups-direct-usb.patch
Patch9: cups-lpr-help.patch
Patch10: cups-peercred.patch
Patch11: cups-pid.patch
Patch12: cups-eggcups.patch
Patch13: cups-getpass.patch
Patch14: cups-driverd-timeout.patch
Patch15: cups-strict-ppd-line-length.patch
Patch16: cups-logrotate.patch
Patch17: cups-usb-paperout.patch
Patch18: cups-build.patch
Patch19: cups-res_init.patch
Patch20: cups-filter-debug.patch
Patch21: cups-uri-compat.patch
Patch22: cups-cups-get-classes.patch
Patch23: cups-str3382.patch
Patch25: cups-0755.patch
Patch26: cups-snmp-quirks.patch
Patch27: cups-hp-deviceid-oid.patch
Patch28: cups-dnssd-deviceid.patch
Patch29: cups-ricoh-deviceid-oid.patch

Patch30: cups-avahi-1-config.patch
Patch31: cups-avahi-2-backend.patch
Patch32: cups-avahi-3-timeouts.patch
Patch33: cups-avahi-4-poll.patch
Patch34: cups-avahi-5-services.patch

Patch35: cups-icc.patch
Patch36: cups-systemd-socket.patch

Patch50: cups-lspp.patch

### MAGEIA PATCHES ###
Patch100: cups-1.4.0-recommended.patch
# Ubuntu patch, Launchpad #449586: Do not use host
# names for broadcasting print queues and managing print queues broadcasted
# from other servers by default. Many networks do not have valid host names
# for all machines
Patch101: cups-1.5.0-no-hostname-broadcast.patch
Patch102: cups-1.5.4-CVE-2012-5519.diff
# http://www.cups.org/str.php?L4155
Patch103: usb-backend-reset-after-job-only-for-specific-devices.patch

##### ADDITIONAL DEFINITIONS #####

Url: http://www.cups.org
Requires: %{name}-common >= %{version}-%{release} 
Requires: openssl 
Requires: net-tools
Requires: printer-testpages
# Take care that device files are created with correct permissions
Requires: udev 
# For desktop menus
Requires: xdg-utils
Suggests: avahi

# Requires /etc/tmpfiles.d (bug #656566)
Requires: systemd-units >= 13
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%if !%bootstrap
Requires:	poppler
%endif
BuildRequires:	autoconf2.5
BuildRequires:	openssl-devel
BuildRequires:	libpam-devel
BuildRequires:	libopenslp-devel, libldap-devel
BuildRequires:	libdbus-devel >= 0.50
BuildRequires:	glibc
BuildRequires:	libgnutls-devel
%if !%bootstrap
BuildRequires:	php-devel >= 5.1.0 php-cli
%endif
BuildRequires:	libjpeg-devel, libpng-devel, libtiff-devel, libz-devel
BuildRequires: htmldoc
%if !%bootstrap
buildRequires:	poppler
BuildRequires: avahi-compat-libdns_sd-devel
%endif
BuildRequires:	acl-devel
Buildrequires:  xinetd
BuildRequires:	libusb-devel
BuildRequires:	krb-devel
BuildRequires:  systemd-units
BuildRequires:  libsystemd-daemon-devel

Requires: 	portreserve
Provides:	cupsddk-drivers
Obsoletes:	cupsddk-drivers < 1.2.3-5
Obsoletes:	cupsddk < 1.4.0

##### SUB-PACKAGES #####

%description
The Common Unix Printing System provides a portable printing layer for 
UNIX(TM) operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces.
This is the main package needed for CUPS servers (machines where a
printer is connected to or which host a queue for a network
printer). It can also be used on CUPS clients so that they simply pick
up broadcasted printer information from other CUPS servers and do not
need to be assigned to a specific CUPS server by an
%{_sysconfdir}/cups/client.conf file.

%pre
%ifarch x86_64
# Fix /usr/lib/cups directory, so that updates can be done
if [ -d %{_libdir}/cups ] && ! [ -h %{_libdir}/cups ]; then
    if [ -h %{cups_serverbin} ] || ! [ -e %{cups_serverbin} ]; then
        rm -f %{cups_serverbin}
        mv %{_libdir}/cups %{cups_serverbin}
    else
        rm -rf %{_libdir}/cups.rpmsave
        mv %{_libdir}/cups %{_libdir}/cups.rpmsave
        #echo 'Moved %{_libdir}/cups to %{_libdir}/cups.rpmsave' 1>&2
    fi
fi
%endif
%_pre_groupadd lpadmin

%post
# Make sure group ownerships are correct
chgrp -R sys %{_sysconfdir}/cups %{_var}/*/cups

# We can't enforce this. Bug #35993
for d in /opt/share/ppd /opt/lib/printdriver /usr/local/share/ppd /usr/local/lib/printdriver
do
  [ ! -e $d ] && mkdir -p $d || :
done
# End of 28383

# Apply our udev rules:
/sbin/udevadm trigger --sysname-match="lp[0-9]*" --sysname-match="parport[0-9]*" --sysname-match="irlpt[0-9]*"
/sbin/udevadm trigger --subsystem-match="usb" --attr-match=bInterfaceClass=07 --attr-match=bInterfaceSubClass=01
# wait for the permissions need to be ready
/sbin/udevadm settle --timeout=15

# Deal with config migration due to CVE-2012-5519 (STR #4223)
IN=%{_sysconfdir}/cups/cupsd.conf
OUT=%{_sysconfdir}/cups/cups-files.conf
copiedany=no
for keyword in AccessLog CacheDir ConfigFilePerm	\
    DataDir DocumentRoot ErrorLog FatalErrors		\
    FileDevice FontPath Group LogFilePerm		\
    LPDConfigFile PageLog Printcap PrintcapFormat	\
    RemoteRoot RequestRoot ServerBin ServerCertificate	\
    ServerKey ServerRoot SMBConfigFile StateDir		\
    SystemGroup SystemGroupAuthKey TempDir User; do
    if ! /bin/grep -iq ^$keyword "$IN"; then continue; fi
    copy=yes
    if /bin/grep -iq ^$keyword "$OUT"; then
	if [ "`/bin/grep -i ^$keyword "$IN"`" ==	\
	     "`/bin/grep -i ^$keyword "$OUT"`" ]; then
	    copy=no
	else
	    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$OUT" || :
	fi
    fi
    if [ "$copy" == "yes" ]; then
	if [ "$copiedany" == "no" ]; then
	    (cat >> "$OUT" <<EOF

# Settings automatically moved from cupsd.conf by RPM package:
EOF
	    ) || :
	fi

	(/bin/grep -i ^$keyword "$IN" >> "$OUT") || :
	copiedany=yes
    fi

    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$IN" || :
done

exit 0

# Let CUPS daemon be automatically started at boot time
%_post_service cups

%preun
# Let CUPS daemon not be automatically started at boot time any more
%_preun_service cups

%postun
%_postun_groupdel lpadmin

%files
%doc *.txt
%attr(511,lp,lpadmin) %{_var}/run/cups/certs
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/cupsd.conf
%config(noreplace) %attr(0640,root,lp) %{_sysconfdir}/cups/cups-files.conf
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/sysconfig/cups
%ghost %config(noreplace) %{_sysconfdir}/cups/printers.conf
%ghost %config(noreplace) %{_sysconfdir}/cups/classes.conf
%attr(-,root,sys) %{_sysconfdir}/cups/cupsd.conf.default
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/interfaces
#%config(noreplace) %attr(644,root,sys) %{_sysconfdir}/cups/mime.convs
#%config(noreplace) %attr(644,root,sys) %{_sysconfdir}/cups/mime.types
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/ppd
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/ssl
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/snmp.conf
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/dbus*/system.d/cups.conf
## FIXME: Remove for mageia3
%{_initrddir}/cups
## END FIXME
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}.socket
%{_unitdir}/%{name}.path
%config(noreplace) %{_sysconfdir}/pam.d/cups
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/cups-lpd
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/portreserve/cups
/lib/udev/rules.d/*.rules
%dir %{cups_serverbin}
%{cups_serverbin}/cgi-bin
%{cups_serverbin}/daemon
%{cups_serverbin}/notifier
%{cups_serverbin}/filter
%{cups_serverbin}/monitor
%dir %{cups_serverbin}/backend
%if !%bootstrap
%{cups_serverbin}/backend/dnssd
%endif
%{cups_serverbin}/backend/http
%{cups_serverbin}/backend/https
%{cups_serverbin}/backend/ipp
%{cups_serverbin}/backend/ipps
%{cups_serverbin}/backend/lpd
%if !%bootstrap
%{cups_serverbin}/backend/mdns
%endif
%{cups_serverbin}/backend/nprint
%{cups_serverbin}/backend/pap
%{cups_serverbin}/backend/parallel
#%{cups_serverbin}/backend/scsi
%{cups_serverbin}/backend/snmp
%{cups_serverbin}/backend/socket
%{cups_serverbin}/backend/usb
%dir %{cups_serverbin}/driver
%{_datadir}/cups
%attr(0755,root,sys) %{_var}/log/cups
# Set ownerships of spool directory which is normally done by 'make install'
# Because RPM does 'make install' as normal user, this has to be done here
%dir %attr(0710,root,sys) %{_var}/spool/cups
%dir %attr(01770,root,sys) %{_var}/spool/cups/tmp
%dir %attr(775,root,sys) %{_var}/cache/cups
# Bug #28383 dirs
%dir %{_datadir}/ppd
%dir %{_libdir}/printdriver
# Desktop icons
%{_datadir}/applications/*
%{_datadir}/icons/hicolor/*/apps/cups.png
%ifarch x86_64
# Compatibility link, will be removed soon
%{_libdir}/cups
%endif

#--------------------------------------------------------------------

%package common
Summary: Common Unix Printing System - Common stuff
License: GPLv2
Group: System/Printing
Requires: %{libname} >= %{version}-%{release} update-alternatives openssl net-tools
# To satisfy LSB/FHS
Provides: lpddaemon

%description common
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. It contains the command line utilities for
printing and administration (lpr, lpq, lprm, lpadmin, lpc, ...), man
pages, locales, and a sample configuration file for daemon-less CUPS
clients (%{_sysconfdir}/cups/client.conf).

This package you need for both CUPS clients and servers. 

%post common
# The lpc updates-alternative links were not correctly set in older CUPS
# packages, therefore remove the entry before making a new one when updating
%{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups || :
# Set up update-alternatives entries
%{_sbindir}/update-alternatives --install %{_bindir}/lpr lpr %{_bindir}/lpr-cups 10 --slave %{_mandir}/man1/lpr.1%{_extension} lpr.1%{_extension} %{_mandir}/man1/lpr-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpq lpq %{_bindir}/lpq-cups 10 --slave %{_mandir}/man1/lpq.1%{_extension} lpq.1%{_extension} %{_mandir}/man1/lpq-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lprm lprm %{_bindir}/lprm-cups 10 --slave %{_mandir}/man1/lprm.1%{_extension} lprm.1%{_extension} %{_mandir}/man1/lprm-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lp lp %{_bindir}/lp-cups 10 --slave %{_mandir}/man1/lp.1%{_extension} lp.1%{_extension} %{_mandir}/man1/lp-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/cancel cancel %{_bindir}/cancel-cups 10 --slave %{_mandir}/man1/cancel.1%{_extension} cancel.1%{_extension} %{_mandir}/man1/cancel-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpstat lpstat %{_bindir}/lpstat-cups 10 --slave %{_mandir}/man1/lpstat.1%{_extension} lpstat.1%{_extension} %{_mandir}/man1/lpstat-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/accept accept %{_sbindir}/accept-cups 10 --slave %{_mandir}/man8/accept.8%{_extension} accept.8%{_extension} %{_mandir}/man8/accept-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/disable disable %{_sbindir}/disable-cups 10 --slave %{_mandir}/man8/disable.8%{_extension} disable.8%{_extension} %{_mandir}/man8/disable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/enable enable %{_sbindir}/enable-cups 10 --slave %{_mandir}/man8/enable.8%{_extension} enable.8%{_extension} %{_mandir}/man8/enable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpc lpc %{_sbindir}/lpc-cups 10 --slave %{_mandir}/man8/lpc.8%{_extension} lpc.8%{_extension} %{_mandir}/man8/lpc-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpmove lpmove %{_sbindir}/lpmove-cups 10 --slave %{_mandir}/man8/lpmove.8%{_extension} lpmove.8%{_extension} %{_mandir}/man8/lpmove-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/reject reject %{_sbindir}/reject-cups 10 --slave %{_mandir}/man8/reject.8%{_extension} reject.8%{_extension} %{_mandir}/man8/reject-cups.8%{_extension}

%preun common
if [ "$1" = 0 ]; then
  # Remove update-alternatives entries
  %{_sbindir}/update-alternatives --remove lpr %{_bindir}/lpr-cups
  %{_sbindir}/update-alternatives --remove lpq %{_bindir}/lpq-cups
  %{_sbindir}/update-alternatives --remove lprm %{_bindir}/lprm-cups
  %{_sbindir}/update-alternatives --remove lp %{_bindir}/lp-cups
  %{_sbindir}/update-alternatives --remove cancel %{_bindir}/cancel-cups
  %{_sbindir}/update-alternatives --remove lpstat %{_bindir}/lpstat-cups
  %{_sbindir}/update-alternatives --remove accept %{_sbindir}/accept-cups
  %{_sbindir}/update-alternatives --remove disable %{_sbindir}/disable-cups
  %{_sbindir}/update-alternatives --remove enable %{_sbindir}/enable-cups
  %{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups
  %{_sbindir}/update-alternatives --remove lpmove %{_sbindir}/lpmove-cups
  %{_sbindir}/update-alternatives --remove reject %{_sbindir}/reject-cups
fi

%files common
#-f %{name}.lang
%dir %config(noreplace) %attr(-,lp,sys) %{_sysconfdir}/cups
%ghost %config(noreplace) %attr(-,lp,sys) %{_sysconfdir}/cups/client.conf
%config(noreplace) %{_sysconfdir}/modprobe.d/blacklist-cups-common.conf
%{_sbindir}/*
%{_bindir}/*cups
%{_bindir}/ipptool
#%{_bindir}/lphelp
%{_bindir}/lpoptions
%attr(6755,root,sys) %{_bindir}/lppasswd
%{_bindir}/photo_print
%{_bindir}/poll_ppd_base
%{_bindir}/ppdc
%{_bindir}/ppdhtml
%{_bindir}/ppdi
%{_bindir}/ppdmerge
%{_bindir}/ppdpo
%{_bindir}/cupstestppd
%{_bindir}/cupstestdsc
%{_bindir}/enable
%{_bindir}/disable
%lang(da) %{_datadir}/locale/da/cups_da.po
%lang(de) %{_datadir}/locale/de/cups_de.po
%lang(es) %{_datadir}/locale/es/cups_es.po
#%lang(et) %{_datadir}/locale/et/cups_et.po
%lang(eu) %{_datadir}/locale/eu/cups_eu.po
%lang(fi) %{_datadir}/locale/fi/cups_fi.po
%lang(fr) %{_datadir}/locale/fr/cups_fr.po
#%lang(he) %{_datadir}/locale/he/cups_he.po
%lang(hu) %{_datadir}/locale/hu/cups_hu.po
%lang(id) %{_datadir}/locale/id/cups_id.po
%lang(it) %{_datadir}/locale/it/cups_it.po
%lang(ja) %{_datadir}/locale/ja/cups_ja.po
%lang(ko) %{_datadir}/locale/ko/cups_ko.po
%lang(nl) %{_datadir}/locale/nl/cups_nl.po
%lang(no) %{_datadir}/locale/no/cups_no.po
%lang(pl) %{_datadir}/locale/pl/cups_pl.po
%lang(pt) %{_datadir}/locale/pt/cups_pt.po
%lang(pt_BR) %{_datadir}/locale/pt_BR/cups_pt_BR.po
%lang(ru) %{_datadir}/locale/ru/cups_ru.po
%lang(sv) %{_datadir}/locale/sv/cups_sv.po
%lang(zh) %{_datadir}/locale/zh/cups_zh.po
%lang(zh_TW) %{_datadir}/locale/zh_TW/cups_zh_TW.po
%{_mandir}/man?/*

#--------------------------------------------------------------------

%package -n %{libname}
Summary: Common Unix Printing System - CUPS library
License: LGPLv2
Group: System/Libraries
Requires: openssl net-tools
Obsoletes: libcups1
Provides: libcups1 = %{version}

%description -n %{libname}
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This package contains the CUPS API library
which contains common functions used by both the CUPS daemon and all
CUPS frontends (lpr-cups, xpp, qtcups, kups, ...).

This package you need for both CUPS clients and servers. It is also
needed by Samba.

%files -n %{libname}
%{_libdir}/libcups.so.*
%{_libdir}/libcupsimage.so.*
%{_libdir}/libcupscgi.so.1
%{_libdir}/libcupsdriver.so.1
%{_libdir}/libcupsmime.so.1
%{_libdir}/libcupsppdc.so.1

#--------------------------------------------------------------------

%package -n %{libname}-devel
Summary: Common Unix Printing System - Development environment "libcups"
License: LGPLv2
Group: Development/C
Requires: libgnutls-devel
Requires: cups-common = %{version}-%{release}
Requires: %{libname} >= %{version}-%{release} openssl openssl-devel
Provides: libcups-devel = %{version}-%{release}
Provides: libcups2_1-devel = %{version}-%{release}
Obsoletes: cups-devel, libcups1-devel
Provides: cups-devel = %{version}, libcups1-devel = %{version}
Conflicts: cupsddk < 1.4.0

%description -n %{libname}-devel
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This is the development package for
creating additional printer drivers, printing software, and other CUPS
services using the main CUPS library "libcups".

%files -n %{libname}-devel
%{_includedir}/cups/*
%multiarch %{multiarch_includedir}/cups/*
%{_libdir}/*.a
%{_libdir}/*.so
%{_bindir}/cups-config

#--------------------------------------------------------------------

%package serial
Summary: Common Unix Printing System - Backend for serial port printers
License: GPLv2
Group: System/Printing
Requires: %{name} >= %{version}-%{release}

%description serial
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This package contains the backend filter
for printers on the serial ports. The auto-detection on the serial
ports takes several seconds (and so the startup time of the CUPS
daemon with this backend present) and therefore it is not recommended
to install this package when one has no serial port printer.

%files serial
%{cups_serverbin}/backend/serial

#--------------------------------------------------------------------

%package -n php-cups
Summary: PHP bindings for the libcups library
License: GPLv2
Group: Development/PHP
Obsoletes: php4-cups
Provides: php4-cups

%description -n php-cups
Provides bindings to the functions of libcups, to give direct access
to the CUPS printing environment from PHP programs.

%files -n php-cups
%doc scripting/php/README
%if !%bootstrap
%attr(0755,root,root) %{_libdir}/php/extensions/*
%endif
%config(noreplace) %{_sysconfdir}/php.d/*

#--------------------------------------------------------------------


##### PREP #####

%prep


%if %{svnsnapshot}
# SVN version
rm -rf $RPM_BUILD_DIR/%{cupstarballname}
%setup -q -n %{cupstarballname}
%else
# Released version
rm -rf $RPM_BUILD_DIR/%{cupsbasename}-%{version}
%setup -q -n %{cupsbasename}-%{real_version}
%endif

# Downdated pstops filter due to problems with multiple page documents
#bzcat %{SOURCE9} > $RPM_BUILD_DIR/%{cupsbasename}-%{real_version}/filter/pstops.c

# Do NEVER use cups.suse (this package is for Mandriva)
#cp -f data/cups.pam data/cups.suse


# Don't gzip man pages in the Makefile, let rpmbuild do it.
%patch1 -p1 -b .no-gzip-man
# Use the system pam configuration.
%patch2 -p1 -b .system-auth
# Prevent multilib conflict in cups-config script.
%patch3 -p1 -b .multilib
# Fix compilation of serial backend.
%patch4 -p1 -b .serial
# Ignore rpm save/new files in the banners directory.
%patch5 -p1 -b .banners
# Use compatibility fallback path for ServerBin.
%patch6 -p1 -b .serverbin-compat
# Don't export SSLLIBS to cups-config.
%patch7 -p1 -b .no-export-ssllibs
# Allow file-based usb device URIs.
%patch8 -p1 -b .direct-usb
# Add --help option to lpr.
%patch9 -p1 -b .lpr-help
# Fix compilation of peer credentials support.
%patch10 -p1 -b .peercred
# Maintain a cupsd.pid file.
%patch11 -p1 -b .pid
# Fix implementation of com.redhat.PrinterSpooler D-Bus object.
%patch12 -p1 -b .eggcups
# More sophisticated implementation of cupsGetPassword than getpass.
%patch13 -p1 -b .getpass
# Increase driverd timeout to 70s to accommodate foomatic.
%patch14 -p1 -b .driverd-timeout
# Only enforce maximum PPD line length when in strict mode.
%patch15 -p1 -b .strict-ppd-line-length
# Re-open the log if it has been logrotated under us.
%patch16 -p1 -b .logrotate
# Support for errno==ENOSPACE-based USB paper-out reporting.
%patch17 -p1 -b .usb-paperout
# Simplify the DNSSD parts so they can build using the compat library.
%patch18 -p1 -b .build
# Re-initialise the resolver on failure in httpAddrGetList().
%patch19 -p1 -b .res_init
# Log extra debugging information if no filters are available.
%patch20 -p1 -b .filter-debug
# Allow the usb backend to understand old-style URI formats.
%patch21 -p1 -b .uri-compat
# Fix support for older CUPS servers in cupsGetDests.
%patch22 -p1 -b .cups-get-classes
# Fix temporary filename creation.
%patch23 -p1 -b .str3382
# Use mode 0755 for binaries and libraries where appropriate.
%patch25 -p1 -b .0755
# Handle SNMP supply level quirks (bug #581825).
%patch26 -p1 -b .snmp-quirks
# Add an SNMP query for HP's device ID OID (STR #3552).
%patch27 -p1 -b .hp-deviceid-oid
# Mark DNS-SD Device IDs that have been guessed at with "FZY:1;".
%patch28 -p1 -b .dnssd-deviceid
# Add an SNMP query for Ricoh's device ID OID (STR #3552).
%patch29 -p1 -b .ricoh-deviceid-oid

# Avahi support:
# - discovery in the dnssd backend
# - service announcement in the scheduler
%patch30 -p1 -b .avahi-1-config
%patch31 -p1 -b .avahi-2-backend
%patch32 -p1 -b .avahi-3-timeouts
%patch33 -p1 -b .avahi-4-poll
%patch34 -p1 -b .avahi-5-services

# ICC colord support.
%patch35 -p1 -b .icc

# Add support for systemd socket activation (patch from Lennart
# Poettering).
%patch36 -p1 -b .systemd-socket

%if %lspp
# LSPP support.
%patch50 -p1 -b .lspp
%endif

# Patch away ugly "(Recommended)" tag removal
%patch100 -p1 -b .recommended
%patch101 -p1 -b .broadcast
%patch102 -p1 -b .CVE-2012-5519
%patch103 -p1 -b .#8318

# Set CUPS users and groups
perl -p -i -e 's:(SystemGroup\s+.*)$:$1\nGroup sys\nUser lp:' conf/cupsd.conf.in

# Let local printers be broadcasted in the local network(s)
perl -p -i -e 's:(Listen\s+)localhost:$1*:' conf/cupsd.conf.in
perl -p -i -e 's:(Browsing\s+On):$1\nBrowseAddress \@LOCAL:' conf/cupsd.conf.in
perl -p -i -e 's:(<Location\s+/\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Allow remote administration in local network (connections are encrypted,
# so no security problem)
perl -p -i -e 's:(<Location\s+/admin(|/conf)\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Replace the PAM configuration file
cat << EOF > scheduler/cups.pam
auth	include	system-auth
account	include	system-auth
EOF
cp -f scheduler/cups.pam conf/pam.std.in

# Let the Makefiles not trying to set file ownerships
perl -p -i -e "s/ -o \\$.CUPS_USER.//" scheduler/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" scheduler/Makefile
perl -p -i -e "s/ -o \\$.CUPS_USER.//" systemv/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" systemv/Makefile

# Correct hard-coded path for pam_appl.h
#perl -p -i -e 's:pam/pam_appl.h:security/pam_appl.h:' config-scripts/cups-pam.m4 */*.[ch]*

# Work around bug on Mandriva compilation cluster (32-bit machine has
# /usr/lib64 directory)
perl -p -i -e 's:(libdir=")\$exec_prefix/lib64("):$1%{_libdir}$2:' config-scripts/cups-directories.m4 configure

# Let's look at the compilation command lines.
perl -p -i -e "s,^.SILENT:,," Makedefs.in

# Load additional tools
cp %{SOURCE1} poll_ppd_base.c
# Do not compile, need to be fixed.
#cp %{SOURCE2} lphelp.c
# Load nprint backend
cp %{SOURCE11} nprint
# Load AppleTalk "pap" backend
%setup -q -T -D -a 12 -n %{cupstarballname}
# Load the "pap" documentation
bzcat %{SOURCE13} > pap-docu.pdf
# Load the "photo_print" utility
cp %{SOURCE14} photo_print
# Load the "cjktexttops" filter
cp %{SOURCE16} cjktexttops



##### BUILD #####

%build
%serverbuild
# For 'configure' the macro is not used, because otherwise one does not get the
# /etc and /var directories correctly hardcoded into the executables (they
# would get /usr/etc and /usr/var. In addition, the "--with-docdir" option
# has to be given because the default setting is broken. "aclocal" and 
# "autoconf" are needed if we have a Subversion snapshot or patched the
# files of the build system.
%if %{svnsnapshot}
aclocal
WANT_AUTOCONF_2_5=1 autoconf
%endif
aclocal -I config-scripts
autoconf -I config-scripts

# for the PHP module
%define _disable_ld_no_undefined 1
%setup_compile_flags
# cups uses $DSOFLAGS instead of $LDFLAGS for shared libs
export DSOFLAGS="$LDFLAGS"
#--enable-debug keeps debug symbols, doesn't affect anything else
%configure \
    --enable-debug \
    --enable-avahi \
    --disable-libpaper \
    --enable-raw-printing \
    --enable-ssl \
    --enable-static \
    --with-cups-group=sys \
    --with-cups-user=lp \
    --with-docdir=%{_datadir}/cups/doc \
    --with-icondir=%{_datadir}/icons \
    --with-system-groups="lpadmin root" \
%if !%bootstrap
    --with-pdftops=pdftops
%endif

# Remove hardcoded "chgrp" from Makefiles
perl -p -i -e 's/chgrp/:/' Makefile */Makefile

make CHOWN=":" REQUESTS=%{buildroot}%{_var}/spool/cups \
             LOGDIR=%{buildroot}%{_var}/log/cups \
             STATEDIR=%{buildroot}%{_var}/run/cups

# Compile additional tools
gcc %optflags %ldflags -opoll_ppd_base -I. -I./cups poll_ppd_base.c -L./cups -lcups
#gcc %optflags %ldflags -olphelp -I. -I./cups lphelp.c -L./cups -lcups

%if %test
%check
export LC_ALL=C
export LC_MESSAGES=C
export LANG=C
export LANGUAGE=C
make test << EOF

EOF
%endif

##### INSTALL #####

%install
rm -rf %{buildroot}

make install BUILDROOT=%{buildroot} \
             DOCDIR=%{buildroot}%{_datadir}/cups/doc \
             CHOWN=":" CHGRP=":" \
             LOGDIR=%{buildroot}%{_var}/log/cups \
             REQUESTS=%{buildroot}%{_var}/spool/cups \
             STATEDIR=%{buildroot}%{_var}/run/cups

# Make a directory for PPD generators
mkdir -p %{buildroot}%{cups_serverbin}/driver

# Make a directory for the SSL files
mkdir -p %{buildroot}%{_sysconfdir}/cups/ssl

# Make a directory for authentication certificates
mkdir -p %{buildroot}%{_var}/run/cups/certs

# Make a directory for logrotate configuration
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d

# Install additional tools
install -m 755 poll_ppd_base %{buildroot}%{_bindir}
#install -m 755 lphelp %{buildroot}%{_bindir}

# Install nprint backend
install -m 755 nprint %{buildroot}%{cups_serverbin}/backend/

# Install AppleTalk backend
install -m 755 pap-backend/pap %{buildroot}%{cups_serverbin}/backend/
install -m 644 pap-docu.pdf %{buildroot}%{_datadir}/%{cupsbasename}/doc

# Link dnssd backend as mdns backend
(cd %{buildroot}%{cups_serverbin}/backend && ln -s dnssd mdns)

# Install "photo_print"
install -m 755 photo_print %{buildroot}%{_bindir}

# Install "cjktexttops"
install -m 755 cjktexttops %{buildroot}%{cups_serverbin}/filter/

# Install logrotate configuration
install -c -m 644 %{SOURCE9} %{buildroot}%{_sysconfdir}/logrotate.d/cups

# Set link to test page in /usr/share/printer-testpages
#rm -f %{buildroot}%{_datadir}/cups/data/testprint.ps
ln -s %{_datadir}/printer-testpages/testprint.ps %{buildroot}%{_datadir}/cups/data/testprint-mga.ps

# Install startup script
install -d %{buildroot}%{_initrddir}
install -m 755 %{SOURCE5} %{buildroot}%{_initrddir}/cups
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE18} %{buildroot}%{_sysconfdir}/sysconfig/cups
install -d %{buildroot}%{_sysconfdir}/modprobe.d
install -m 644 %{SOURCE19} %{buildroot}%{_sysconfdir}/modprobe.d/blacklist-cups-common.conf
rm -f %{buildroot}%{_sysconfdir}/init.d/cups

# Serial backend needs to run as root (bug RHBZ #212577).
chmod 700 $RPM_BUILD_ROOT%{cups_serverbin}/backend/serial

mkdir -p $RPM_BUILD_ROOT%{_unitdir}

# https://qa.mandriva.com/show_bug.cgi?id=23846
install -d %{buildroot}%{_sysconfdir}/portreserve
echo "ipp" > %{buildroot}%{_sysconfdir}/portreserve/cups

# Install script for automatic CUPS configuration
cp %{SOURCE7} %{buildroot}%{_sbindir}/correctcupsconfig
chmod a+rx %{buildroot}%{_sbindir}/correctcupsconfig

# Install PPDs
mkdir -p %{buildroot}%{_datadir}/cups/model
#install -m 755 ppd/*.ppd %{buildroot}%{_datadir}/cups/model

# Uncompress Perl script for cleaning up manufacturer entries in PPD files
cp %{SOURCE6} ./cleanppd.pl
chmod a+rx ./cleanppd.pl
# Do the clean-up
find %{buildroot}%{_datadir}/cups/model -name "*.ppd" -exec ./cleanppd.pl '{}' \;

# bzip2 all man pages already now, so that we can link man pages without
# RPM breaking it. Links need to be deleted and afterwards regenerated
rm -f %{buildroot}%{_mandir}/man8/cupsdisable.8
rm -f %{buildroot}%{_mandir}/man8/reject.8
#bzme -F %{buildroot}%{_mandir}/man*/*.[0-9n].gz

# Set compatibility links for the man pages and executables
ln -s %{_sbindir}/cupsenable %{buildroot}%{_bindir}/enable
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_bindir}/disable
ln -s %{_sbindir}/cupsenable %{buildroot}%{_sbindir}/enable
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_sbindir}/disable
%if %manpagelinks
ln -s %{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/cupsdisable.8
ln -s %{_mandir}/man8/cupsdisable.8 %{buildroot}%{_mandir}/man8/disable.8
ln -s %{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/enable.8
ln -s %{_mandir}/man8/accept.8 %{buildroot}%{_mandir}/man8/reject.8
%else
cp %{buildroot}%{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/cupsdisable.8
cp %{buildroot}%{_mandir}/man8/cupsdisable.8 %{buildroot}%{_mandir}/man8/disable.8
cp %{buildroot}%{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/enable.8
cp %{buildroot}%{_mandir}/man8/accept.8 %{buildroot}%{_mandir}/man8/reject.8
%endif

%ifarch x86_64
# This one will be removed soon, when all other packages are
# modified appropriately
ln -s %{cups_serverbin} %{buildroot}%{_libdir}/cups
%endif

# prepare the commands conflicting with LPD for the update-alternatives
# treatment
( cd %{buildroot}%{_bindir}
  mv lpr lpr-cups
  mv lpq lpq-cups
  mv lprm lprm-cups
  mv lp lp-cups
  mv cancel cancel-cups
  mv lpstat lpstat-cups
)
( cd %{buildroot}%{_sbindir}
  mv accept accept-cups
  mv disable disable-cups
  mv enable enable-cups
  mv lpc lpc-cups
  mv lpmove lpmove-cups
  mv reject reject-cups
)
( cd %{buildroot}%{_mandir}/man1
  mv lpr.1 lpr-cups.1
  mv lpq.1 lpq-cups.1
  mv lprm.1 lprm-cups.1
  mv lp.1 lp-cups.1
  mv cancel.1 cancel-cups.1
  mv lpstat.1 lpstat-cups.1
)
( cd %{buildroot}%{_mandir}/man8
  mv accept.8 accept-cups.8
  mv disable.8 disable-cups.8
  mv enable.8 enable-cups.8
  mv lpc.8 lpc-cups.8
  mv lpmove.8 lpmove-cups.8
  mv reject.8 reject-cups.8
)
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/reject-cups
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsdisable
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsenable

# Remove links to the startup script, we make our own ones with chkconfig
rm -rf %{buildroot}%{_sysconfdir}/rc?.d/[SK]*
# Remove superflouus man page stuff
rm -rf %{buildroot}%{_mandir}/cat
rm -rf %{buildroot}%{_mandir}/cat?
rm -rf %{buildroot}%{_mandir}/*/cat
rm -rf %{buildroot}%{_mandir}/*/cat?

# Install missing headers (Thanks to Oden Eriksson)
install -m644 cups/debug-private.h  %{buildroot}%{_includedir}/cups/
install -m644 cups/string-private.h %{buildroot}%{_includedir}/cups/
install -m644 config.h %{buildroot}%{_includedir}/cups/

# Multiarch fixes
%multiarch_includes %{buildroot}%{_includedir}/cups/config.h

# Create dummy config files /etc/cups/printers.conf,
# /etc/cups/classes.conf, and /etc/cups/client.conf
touch %{buildroot}%{_sysconfdir}/cups/printers.conf
touch %{buildroot}%{_sysconfdir}/cups/classes.conf
touch %{buildroot}%{_sysconfdir}/cups/client.conf

# Create .ini file for the PHP bindings
install -d %{buildroot}%{_sysconfdir}/php.d
cat > %{buildroot}%{_sysconfdir}/php.d/A20_cups.ini << EOF
extension = phpcups.so
EOF

# Prefer xdg-utils than htmlview (kde one)
sed -i s/htmlview/xdg-open/ %{buildroot}%{_datadir}/applications/*.desktop

#find_lang %{name}

# http://qa.mandriva.com/show_bug.cgi?id=28383
# Common PPD dirs
mkdir -p %{buildroot}%{_datadir}/ppd

# Make CUPS know them
ln -s /usr/local/share/ppd %{buildroot}%{_datadir}/cups/model/1-local-admin
ln -s /opt/share/ppd %{buildroot}%{_datadir}/cups/model/2-third-party
ln -s %{_datadir}/ppd %{buildroot}%{_datadir}/cups/model/3-distribution

# Common printer driver dirs
mkdir -p %{buildroot}%{_libdir}/printdriver
# Other dirs can't be handled here, but on %post instead.

# Install udev rules for letting backends access the printer devices.  Once
# CUPS runs backends as group 'lp', instead of 'sys, we may remove this.
mkdir -p %{buildroot}/lib/udev/rules.d
install -m 644 %{SOURCE3} %{buildroot}/lib/udev/rules.d/




%changelog

* Sun Dec 16 2012 oden <oden> 1.5.4-1.1.mga2
+ Revision: 331722
- P103: attempt to fix #8318 (some usb printers stopped working)
- 1.5.4
- sync patches and some changes from cauldron
- P102: security fix for CVE-2012-5519 (upstream, redhat)
- merge spec file changes from fedora to deal with the new cups-files.conf file

  + guillomovitch <guillomovitch>
    - add upstream patches to fix #4673

  + tmb <tmb>
    - Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 27 2012 tmb <tmb> 1.5.2-4.mga2
+ Revision: 233546
- rebuild for versioned rpm-helper requires

* Mon Apr 02 2012 zezinho <zezinho> 1.5.2-3.mga2
+ Revision: 227831
- blacklist usblp as it prevents usb printer detection

* Mon Mar 26 2012 anssi <anssi> 1.5.2-2.mga2
+ Revision: 226537
- apply udev rules immediately in %%post, while changing the rules to be
  run on ACTION=="change" as well (part of bug #3616 fix (automatic printer
  installation))
- make cups %%pre more robust when cups is uninstalled and reinstalled
  multiple times

* Tue Feb 14 2012 colin <colin> 1.5.2-1.mga2
+ Revision: 208638
- New version: 1.5.2
- Add Hungarian translation
- Drop patches applied upstream
- Rediff (resync with Fedora) patches which do not apply

* Thu Dec 22 2011 fwang <fwang> 1.5.0-2.mga2
+ Revision: 186112
- rebuild for new libtiff

* Tue Dec 13 2011 dmorgan <dmorgan> 1.5.0-1.mga2
+ Revision: 181225
- New version 1.5.0
  Sync with Fedora
  Clean spec file

* Wed Oct 26 2011 doktor5000 <doktor5000> 1.4.8-3.mga2
+ Revision: 158294
- removed -fPIC from CFLAGS and CXXFLAGS
- properly add our {C,CXX,LD)FLAGS via %%setup_compile_flags
- exported our LDFLAGS as DSOFLAGS as cups uses those internally
- remove stripping handling, was not working before
- use %%optflags and %%ldflags for compiling the additional tools
- enable _disable_ld_no_undefined for the PHP module
- removed seperate debug handling
  o enabled back proper creation of -debug packages
  o moved debug symbols back from binary packages to -debug packages
- removed obsolete empty %%defattr and %%clean sections
- fixed CVE-2011-3170, heap-based buffer overflow allows remote attackers
  to possibly execute arbitrary code (str3914.patch, from upstream)

* Sat Sep 10 2011 fwang <fwang> 1.4.8-2.mga2
+ Revision: 142089
- rebuild for new libpng

* Thu Sep 08 2011 tv <tv> 1.4.8-1.mga2
+ Revision: 141579
- add missing LSB keywords
- rediff patch 35
- new release

* Mon Jun 20 2011 tv <tv> 1.4.6-4.mga2
+ Revision: 110405
- cups-devel requires gnutls-devel, otherwise cups-config fails

* Mon Mar 21 2011 dmorgan <dmorgan> 1.4.6-3.mga1
+ Revision: 75102
- Do not build in bootstrap mode anymore
- Remove old and buggy pdfdistiller ( tks to Luc Menut #483 )

* Sat Feb 19 2011 blino <blino> 1.4.6-2.mga1
+ Revision: 54313
- move printer device acl fix from system-config-printer-udev to cups
  (so that cups works standalone)

* Wed Jan 12 2011 dmorgan <dmorgan> 1.4.6-1.mga1
+ Revision: 7269
- Fix file list
- Do not make check now
- Rebuild with htmldoc
- Do not build htmldoc for now
- Do not build with avahi support for now
- Do not build php support for now
- Remove mdv macros
- Remove mdv macros
- imported package cups

  + ahmad <ahmad>
    - imported package cups

